<!DOCTYPE html>
<html lang="en"
      xmlns:layout="http://www.ultraq.net.nz/thymeleaf/layout"
      xmlns:th="http://www.thymeleaf.org"
      xmlns:sec="http://www.thymeleaf.org/extras/spring-security"
      layout:decorate="~{layout}">
<head>
    <meta charset="UTF-8">
    <title>Journal Template Detail</title>
</head>
<body>
<main layout:fragment="main" class="container-xxl bd-gutter mt-3 my-md-4 bd-layout">
    <div th:include="sidebar/sidebar_setting::sidebar_setting" th:remove="tag">
        sidebar
    </div>
    <main class="bd-main-xxl">
        <div class="row">
            <div class="col-md-12 mb-3">
                <div class="card shadow-sm">
                    <div class="card-header">
                        <h5>Journal Template Detail ( Code : <span th:text="${journalTemplate.code}"></span>)</h5>
                    </div>
                    <div class="card-body">
                        <div class="row">
                            <div class="col-md-12">
                                <form th:action="@{/journal-template/detail/save}" method="post">
                                    <div class="form-group mb-2">
                                        <label>Sequence</label>
                                        <input type="hidden" th:value="${journalTemplate.id}" id="id" name="journalTemplate">
                                        <input type="text" th:value="${sequence}" class="form-control" disabled>
                                        <input type="hidden" th:value="${sequence}" name="sequence">
                                    </div>
                                    <div class="form-group mb-2">
                                        <label>Account</label>
                                        <select class="form-select" id="select" onkeyup="checkCode(this)" onchange="checkCode(this)" name="account" required>
                                            <option value="">Choose One</option>
                                            <option th:each="data, row:${listAccount}"
                                                    th:text="${data.code + ' - ' + data.name}"
                                                    th:value="${data.id}"></option>
                                        </select>
                                        <span id="validateCode" style="color: red; display: none;">* the account has already been used</span>
                                    </div>
                                    <div class="form-group mb-2">
                                        <label>Balance Type</label>
                                        <select name="balanceType" class="form-select" required>
                                            <option value="">Choose One</option>
                                            <option value="DEBET">DEBET</option>
                                            <option value="CREDIT">CREDIT</option>
                                        </select>
                                    </div>
                                    <div class="form-group mb-2">
                                        <button type="submit" id="btnSubmit" class="btn btn-success">Save</button>
                                        <a th:href="@{/journal-template}" class="btn btn-danger">Back</a>
                                    </div>
                                </form>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
            <div class="col-md-12 mb-3">
                <div class="card shadow-sm">
                    <div class="card-header">
                        <h5>Detail Data</h5>
                    </div>
                    <div class="card-body">
                        <div class="table-responsive">
                            <table class="table table-bordered table-striped">
                                <thead>
                                <tr>
                                    <th style="width: 30px;">Sequence</th>
                                    <th>Code</th>
                                    <th>Name</th>
                                    <th style="width: 150px;">Balance Type</th>
                                </tr>
                                </thead>
                                <tbody>
                                <tr th:each="data, row:${listDetail}">
                                    <td th:text="${data.sequence}"></td>
                                    <td th:text="${data.account.code}"></td>
                                    <td th:text="${data.account.name}"></td>
                                    <td>
                                        <span th:text="${data.balanceType}"
                                              th:if="${data.balanceType.toString() == 'DEBET'}" class="badge text-bg-success"></span>
                                        <span th:text="${data.balanceType}"
                                              th:if="${data.balanceType.toString() == 'CREDIT'}" class="badge text-bg-warning"></span>
                                    </td>
                                </tr>
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </main>
</main>
<div layout:fragment="footer" class="script">
    <script>

        var delay = (function () {
            var timer = 0;
            return function (callback, ms) {
                clearTimeout(timer);
                timer = setTimeout(callback, ms);
            };
        })();

        function checkCode(arg) {
            var value = arg.value;
            var id = $('#id').val();

            $(document).change(function (e) {
                delay(function () {
                    var url = "/api/account/check-template?id=" + id + "&code=" + value;
                    $.getJSON(url, function (data) {
                        if (data.code == 'FORBIDDEN'){
                            document.getElementById("validateCode").style.display = "block";
                            document.getElementById("btnSubmit").disabled = true;
                            console.log(data.message)
                        }else {
                            document.getElementById("validateCode").style.display = "none";
                            document.getElementById("btnSubmit").disabled = false;
                            console.log(data.message)
                        }

                    })

                }, 200);

            });
        }
        $('#select').select2({
            theme: 'bootstrap-5',
            placeholder: '- Select Account -'
        });

    </script>
</div>
</body>
</html>